// $Id: botdb.h,v 1.5 2003/05/25 17:17:50 toast Exp $

#ifndef __BOTDB_H__
#define __BOTDB_H__

// Std C++ Headers
#include <string>
#include <iostream>

// OOMon Headers
#include "oomon.h"

// Conditional Headers
#include <sys/stat.h>
#if defined(HAVE_LIBGDBM)
# include <gdbm.h>
#elif defined(HAVE_BSDDB)
# include <sys/types.h>
# include <limits.h>
# include <fcntl.h>
# include <db.h>
#else
# include <map>
#endif


class BotDB
{
public:
  BotDB(const std::string & file, int mode = (S_IRUSR | S_IWUSR));
  ~BotDB();

  int del(const std::string & key);
  int fd();
  int get(const std::string & key, std::string & data);
  int put(const std::string & key, const std::string & data);
  int sync();

  static int db_errno();
  static std::string strerror(const int db_errno);

private:
#if defined(HAVE_LIBGDBM)
  GDBM_FILE db;
#elif defined(HAVE_BSDDB)
  DB *db;
  static int _errno;
#else
  typedef std::map<std::string, std::string> DBMap;
  DBMap db;
#endif
};


#endif /* __BOTDB_H__ */

