// $Id: dcclist.h,v 1.6 2003/01/30 16:39:36 toast Exp $

#ifndef __DCCLIST_H__
#define __DCCLIST_H__

// Std C++ headers
#include <string>
#include <list>

// OOMon headers
#include "strtype"
#include "oomon.h"
#include "config.h"
#include "dcc.h"
#include "watch.h"


class DCCList
{
public:
  bool connect(const DCC::Address address, const int port,
    const std::string & nick, const std::string & userhost);
  bool listen(const std::string & nick, const std::string & userhost);
  void setAllFD(fd_set & readset, fd_set & writeset);
  void processAll(const fd_set & readset, const fd_set & writeset);
  void sendAll(const std::string & message, const int flags = UF_NONE,
    const WatchSet & watches = WatchSet(), const DCC *exception = NULL);
  void sendAll(const std::string & message, const int flags,
    const Watch watch, const DCC *exception = NULL);
  bool sendTo(const std::string & handle, const std::string & message,
    const int flags = UF_NONE, const WatchSet & watches = WatchSet());
  bool sendTo(const std::string & handle, const std::string & message,
    const int flags, const Watch watch);
  bool chat(const std::string & from, const std::string & to,
    std::string message, const DCC *exception = (DCC *) 0);
  void who(StrList &);
  void statsP(StrList &);

  void status(StrList & output) const;

  DCCList() { };
  ~DCCList();

private:
  typedef std::list<DCC *> SockList;
  SockList connections;
  SockList listeners;

  DCC *find(const std::string &);
};


extern DCCList clients;


#endif /* __DCCLIST_H__ */

