// $Id: engine.h,v 1.42 2003/05/06 16:40:00 toast Exp $

#ifndef __ENGINE_H__
#define __ENGINE_H__

#include <string>

#include "strtype"
#include "autoaction.h"


enum KlineType
{
  MK_CLONES, MK_FLOODING, MK_BOTS, MK_SPAM, MK_LINKS, MK_TRACE, MK_MOTD,
  MK_INFO, MK_STATS, MK_PROXY
};


void Init_Link_Look_Table();
void Init_Nick_Change_Table();

void onTraceUser(const std::string &, const std::string &, const std::string &,
  std::string, std::string);
void onTraceUser(const std::string &, const std::string &, const std::string &,
  std::string);
void onTraceClass();
void onClientConnect(std::string);
void onClientExit(std::string);
void onNickChange(std::string);
void onLinksNotice(std::string text);
void onTraceNotice(const std::string & text);
void onMotdNotice(const std::string & text);
void onInfoNotice(const std::string & text);
void onStatsNotice(std::string text);
void onOperNotice(std::string text);
void onInvalidUsername(std::string text);

void Bot_Reject(std::string);
void CS_Clones(std::string);
void CS_Nick_Flood(std::string);

void Kill_Add_Report(std::string);

std::string Make_Kline(const std::string &, const KlineType, const int);
void suggestKline(const bool kline, std::string User, const std::string & Host,
  const bool different, const bool identd, const KlineType Reason);
void CheckProxy(const std::string &, const std::string &, const std::string &,
  const std::string &);

bool checkForSpoof(const std::string & nick, const std::string & user, 
  const std::string & host, const std::string & ip);
void addIP(std::string ip);

void status(StrList & output);


#define REASON_CLONES	"Clones are prohibited"
#define REASON_FLOODING	"Flooding is prohibited"
#define REASON_BOTS	"Bots are prohibited"
#define REASON_SPAM	"Spamming is prohibited"
#define REASON_LINKS	"Links lookers are prohibited"
#define REASON_TRACE	"TRACE flooding is prohibited"
#define REASON_MOTD	"MOTD flooding is prohibited"
#define REASON_INFO	"INFO flooding is prohibited"
#define REASON_STATS	"STATS flooding is prohibited"
#define REASON_PROXY	"Open Proxy"

#endif /* __ENGINE_H__ */

