// $Id: flood.h,v 1.5 2003/02/09 22:39:52 toast Exp $

#ifndef __FLOOD_H__
#define __FLOOD_H__


// Std C++ Headers
#include <string>
#include <list>

// Std C Headers
#include <time.h>

// OOMon Headers
#include "engine.h"
#include "vars.h"


class FloodList
{
public:
  FloodList(const std::string & type, VarNum actionVar, VarNum reasonVar,
    VarNum maxCountVar, VarNum maxTimeVar)
  {
    this->type = type;
    this->actionVar = actionVar;
    this->reasonVar = reasonVar;
    this->maxCountVar = maxCountVar;
    this->maxTimeVar = maxTimeVar;
  };

  void clear() { this->list.clear(); };


  std::string getType() const { return this->type; };
  VarNum getActionVar() const { return this->actionVar; };
  VarNum getReasonVar() const { return this->reasonVar; };
  int getMaxCount() const { return vars[this->maxCountVar]->getInt(); };
  int getMaxTime() const { return vars[this->maxTimeVar]->getInt(); };

  void onNotice(const std::string & notice, std::string text,
    time_t now = time(NULL));

  int size() const { return this->list.size(); };

private:
  class FloodEntry
  {
  public:
    std::string	userhost;
    int		count;
    time_t	last;
  };

  std::list<FloodEntry> list;

  std::string type;
  VarNum actionVar;
  VarNum reasonVar;
  VarNum maxCountVar;
  VarNum maxTimeVar;

  void addFlood(const std::string & nick, const std::string & userhost,
    time_t now, bool local);
};

#endif /* __FLOOD_H__ */

