// $Id: http.cc,v 1.5 2003/01/23 15:48:46 toast Exp $

// Std C++ headers
#include <iostream>
#include <fstream>
#include <string>

// OOMon headers
#include "oomon.h"
#include "http.h"
#include "log.h"
#include "main.h"
#include "irc.h"
#include "engine.h"
#include "config.h"
#include "util.h"


#ifdef DEBUG
# define HTTP_DEBUG
#endif


// OnConnect()
//
//
bool
Http::onConnect()
{
#ifdef HTTP_DEBUG
  cout << "HTTP CONNECT proxy detector connected to " << this->getAddress() <<
    ":" << this->getPort() << endl;
#endif

  std::string buffer("CONNECT " + Config::GetServerHostName() +
    ":" + ULongToStr(Config::GetServerPort()) + " HTTP/1.0\n\n");

#ifdef HTTP_DEBUG
  cout << "HTTP << " << buffer << endl;
#endif

  if (this->write(buffer + "\r\n\r\n") > 0)
  {
    return true;
  }

  return false;
}


bool
Http::onRead(std::string text)
{
#ifdef HTTP_DEBUG
  cout << "HTTP >> " << text << endl;
#endif

  if ((std::string::npos != text.find("HTTP/1.0 200 Connection established")) ||
    (std::string::npos != text.find("HTTP/1.1 200 Connection established")))
  {
#ifdef HTTP_DEBUG
    cout << "OPEN HTTP CONNECT PROXY DETECTED!" << endl;
#endif
    this->detectedProxy();
  }
  return false;
}

