// $Id: klines.h,v 1.12 2003/02/23 23:35:51 toast Exp $

#ifndef _KLINES_H_
#define _KLINES_H_

#include <string>
#include <list>

#include "strtype"

class KlineItem
{
public:
  KlineItem(const std::string & userhost = "", const std::string & reason = "")
  {
    this->userhost = userhost;
    this->reason = reason;
  }
  std::string userhost;
  std::string reason;
};


class KlineList
{
private:
  std::list<KlineItem> Klines; 
  char lineType;

public:
  KlineList(const char lineType = 'K') { this->lineType = lineType; }
  void Clear();
  void Add(const std::string &, const std::string &);
  void find(StrList & Output, const std::string & userhost, bool count = false)
    const;
  int findAndRemove(const std::string & from, const std::string & userhost);
  void Remove(const std::string &);
  void ParseAndAdd(std::string);
  void onExpireNotice(std::string text);
  void ParseAndRemove(std::string);
  std::list<KlineItem>::size_type size() const { return Klines.size(); };
};

#endif
