// $Id: socks4.cc,v 1.9 2003/02/23 23:35:52 toast Exp $

// Std C headers
#include <sys/types.h> 				// for getpwuid(3)
#include <pwd.h>				// for getpwuid(3)
#include <errno.h>				// for errno

// Std C++ headers
#include <iostream>
#include <fstream>
#include <string>

// OOMon headers
#include "oomon.h"
#include "socks4.h"
#include "log.h"
#include "main.h"
#include "engine.h"
#include "irc.h"


#ifdef DEBUG
# define SOCKS4_DEBUG
#endif


// OnConnect()
//
//
bool
Socks4::onConnect()
{
#ifdef SOCKS4_DEBUG
  cout << "SOCKS4 proxy detector connected to " << this->getAddress() << ":" <<
    this->getPort() << endl;
#endif

  struct passwd *tmppw = getpwuid(getuid());

  char *tmp;

  if (tmppw)
    tmp = tmppw->pw_name;
  else
    tmp = "unknown";

  BotSock::Port port = htons(Config::GetServerPort());
  BotSock::Address dst = htonl(server.getRemoteAddress());

  char buff[2048];

  buff[0] = 4;
  buff[1] = 1;
  strncpy(&buff[2], (char *)&port, 2);
  strncpy(&buff[4], (char *)&dst, 4);
  strncpy(&buff[8], tmp, 1000);

  int m = strlen(tmp) + 5;

  int n = this->write(buff, m);

  if (n < 0)
  {
    cerr << "Error: Write " << errno << " (" << strerror(errno) << ")" << endl;
    return false;
  }
  else if (n == 0)
  {
    return false;
  }
#ifdef SOCKS4_DEBUG
  cout << "Socks4 << " << buff << endl;
#endif
  return true;
}


bool
Socks4::onRead(std::string text)
{
#ifdef SOCKS4_DEBUG
  cout << "Socks4 returned: " << int(text[1]) << endl;
#endif

  if (text[1] == 90)
  {
#ifdef SOCKS4_DEBUG
    cout << "OPEN SOCKS4 PROXY DETECTED!" << endl;
#endif
    this->detectedProxy();
  }
  return false;
}

