// $Id: userdb.cc,v 1.5 2003/05/25 17:17:50 toast Exp $

// Std C++ Headers
#include <string>

// Std C Headers
#include <errno.h>

// OOMon Headers
#include "userdb.h"
#include "util.h"
#include "botexcept.h"


#ifdef DEBUG
# define USERDB_DEBUG
#endif


UserDB *userConfig;


bool
UserDB::getEcho(const std::string & handle)
{
  std::string value;

  int result = this->get(handle + ":echo", value);

#ifdef USERDB_DEBUG
  cout << "db->get() returned " << result << endl;
#endif

  if (1 == result)
  {
    throw OOMon::norecord_error("No ECHO record for " + handle);
  }
  else if (-1 == result)
  {
#ifdef USERDB_DEBUG
    cout << "errno " << errno << endl;
#endif
    throw OOMon::botdb_error("Failed to get ECHO record for " + handle);
  }

  return (0 != atoi(value.c_str()));
}


void
UserDB::setEcho(const std::string & handle, const bool value)
{
  std::string text = IntToStr(value ? 1 : 0);

  int result = this->put(handle + ":echo", text);

#ifdef USERDB_DEBUG
  cout << "db->put() returned " << result << endl;
#endif

  if (1 == result)
  {
    throw OOMon::norecord_error("No ECHO record for " + handle);
  }
  else if (-1 == result)
  {
#ifdef USERDB_DEBUG
    cout << "errno " << errno << endl;
#endif
    throw OOMon::botdb_error("Failed to set ECHO record for " + handle);
  }
}


std::string
UserDB::getWatches(const std::string & handle)
{
  std::string value;

  int result = this->get(handle + ":watches", value);

#ifdef USERDB_DEBUG
  cout << "db->get() returned " << result << endl;
#endif

  if (1 == result)
  {
    throw OOMon::norecord_error("No WATCHES record for " + handle);
  }
  else if (-1 == result)
  {
#ifdef USERDB_DEBUG
    cout << "errno " << errno << endl;
#endif
    throw OOMon::botdb_error("Failed to get WATCHES record for " + handle);
  }

  return value;
}


void
UserDB::setWatches(const std::string & handle, const std::string & value)
{
  int result = this->put(handle + ":watches", value);

#ifdef USERDB_DEBUG
  cout << "db->put() returned " << result << endl;
#endif

  if (1 == result)
  {
    throw OOMon::norecord_error("No WATCHES record for " + handle);
  }
  else if (-1 == result)
  {
#ifdef USERDB_DEBUG
    cout << "errno " << errno << endl;
#endif
    throw OOMon::botdb_error("Failed to set WATCHES record for " + handle);
  }
}

