// $Id: watch.h,v 1.7 2003/02/14 23:13:30 toast Exp $

#ifndef __WATCH_H__
#define __WATCH_H__

// Std C++ Headers
#include <string>
#include <set>

// OOMon Headers
#include "strtype"


enum Watch
{
  WATCH_CHAT, WATCH_CONNECTS, WATCH_DISCONNECTS, WATCH_DLINES,
  WATCH_DLINE_MATCHES, WATCH_KILLS, WATCH_KLINES, WATCH_KLINE_MATCHES,
  WATCH_MSGS, WATCH_NICK_CHANGES, WATCH_SEEDRAND, WATCH_SPAMTRAP, WATCH_TRAPS,
  WATCH_WALLOPS, 

  WATCH_MIN = WATCH_CHAT, WATCH_MAX = WATCH_WALLOPS
};


class WatchSet : private std::set<Watch>
{
public:
  WatchSet(const WatchSet & watches) : std::set<Watch>(watches) { };
  WatchSet() : std::set<Watch>() { };

  void clear() { this->std::set<Watch>::clear(); };

  void add(const Watch watch) { this->std::set<Watch>::insert(watch); };
  void add(const WatchSet & watches);

  void remove(const Watch watch) { this->std::set<Watch>::erase(watch); };
  void remove(const WatchSet & watches);

  bool has(const Watch watch) const
    { return (this->end() != this->find(watch)); };
  bool has(const WatchSet & watches) const;

  void set(StrList & output, std::string line);

  static WatchSet all();
  static WatchSet defaults();
  static std::string getWatchName(const Watch watch);
  static Watch getWatchValue(const std::string & watch);
  static std::string getWatchNames(const WatchSet & watches, bool distinct);
  static WatchSet getWatchValues(const std::string & watches);
  static WatchSet getWatchValues(StrVector & watches);
};


#endif /* __WATCH_H__ */
    
